<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: Library Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_library.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="class_library-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Library Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>model of library with users and books  
 <a href="class_library.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_library_8h_source.html">Library.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a82338219d8bf51962ff5f60a0db21b19"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a82338219d8bf51962ff5f60a0db21b19">Library</a> ()</td></tr>
<tr class="separator:a82338219d8bf51962ff5f60a0db21b19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4712d4a4733c5e2848129756f3396a4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#af4712d4a4733c5e2848129756f3396a4">Library</a> (const <a class="el" href="class_library.html">Library</a> &amp;l)</td></tr>
<tr class="memdesc:af4712d4a4733c5e2848129756f3396a4"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_library.html" title="model of library with users and books ">Library</a> new library.  <a href="#af4712d4a4733c5e2848129756f3396a4">More...</a><br /></td></tr>
<tr class="separator:af4712d4a4733c5e2848129756f3396a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62120f28a9b50cc5b151d868e42ab936"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a62120f28a9b50cc5b151d868e42ab936">~Library</a> ()</td></tr>
<tr class="separator:a62120f28a9b50cc5b151d868e42ab936"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6479360c5ecb4592ab7df4cedc1d331"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">addUser</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; user)</td></tr>
<tr class="memdesc:ad6479360c5ecb4592ab7df4cedc1d331"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new user to library  <a href="#ad6479360c5ecb4592ab7df4cedc1d331">More...</a><br /></td></tr>
<tr class="separator:ad6479360c5ecb4592ab7df4cedc1d331"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae18b352bb538f8f7bbef5eba963feec6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; book)</td></tr>
<tr class="memdesc:ae18b352bb538f8f7bbef5eba963feec6"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new book to library  <a href="#ae18b352bb538f8f7bbef5eba963feec6">More...</a><br /></td></tr>
<tr class="separator:ae18b352bb538f8f7bbef5eba963feec6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a237a223c72cc9c46efbc70b05bfc4067"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a237a223c72cc9c46efbc70b05bfc4067">removeUser</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; user)</td></tr>
<tr class="separator:a237a223c72cc9c46efbc70b05bfc4067"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a553976ddb2812ca85f16d98e747e7e69"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a553976ddb2812ca85f16d98e747e7e69">removeBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; book)</td></tr>
<tr class="memdesc:a553976ddb2812ca85f16d98e747e7e69"><td class="mdescLeft">&#160;</td><td class="mdescRight">removes book from library  <a href="#a553976ddb2812ca85f16d98e747e7e69">More...</a><br /></td></tr>
<tr class="separator:a553976ddb2812ca85f16d98e747e7e69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad102e94fb61ef4db352769970c470ffe"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#ad102e94fb61ef4db352769970c470ffe">editUser</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; oldUser, <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; newUser)</td></tr>
<tr class="memdesc:ad102e94fb61ef4db352769970c470ffe"><td class="mdescLeft">&#160;</td><td class="mdescRight">replaces selected user with new one  <a href="#ad102e94fb61ef4db352769970c470ffe">More...</a><br /></td></tr>
<tr class="separator:ad102e94fb61ef4db352769970c470ffe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a983f569333bcca8e312e28faf4c31299"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a983f569333bcca8e312e28faf4c31299">editBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; oldBook, <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; newBook)</td></tr>
<tr class="memdesc:a983f569333bcca8e312e28faf4c31299"><td class="mdescLeft">&#160;</td><td class="mdescRight">replaces selected book with new one  <a href="#a983f569333bcca8e312e28faf4c31299">More...</a><br /></td></tr>
<tr class="separator:a983f569333bcca8e312e28faf4c31299"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a578ce2622f10276289f4818f745ab67e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a578ce2622f10276289f4818f745ab67e">isUserInDatabase</a> (<a class="el" href="class_user.html">User</a> user) const </td></tr>
<tr class="separator:a578ce2622f10276289f4818f745ab67e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b67293035c9287e553fdf375c2c07d4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a9b67293035c9287e553fdf375c2c07d4">isBookInDatabase</a> (<a class="el" href="class_book.html">Book</a> book) const </td></tr>
<tr class="separator:a9b67293035c9287e553fdf375c2c07d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a525d14bedae90669616814e7bc8b64d2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a525d14bedae90669616814e7bc8b64d2">findUser</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; user) const </td></tr>
<tr class="memdesc:a525d14bedae90669616814e7bc8b64d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">findUser finds users matching query  <a href="#a525d14bedae90669616814e7bc8b64d2">More...</a><br /></td></tr>
<tr class="separator:a525d14bedae90669616814e7bc8b64d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e4254bc287282e010057c3e5badb43b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a1e4254bc287282e010057c3e5badb43b">findBook</a> (<a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; book) const </td></tr>
<tr class="memdesc:a1e4254bc287282e010057c3e5badb43b"><td class="mdescLeft">&#160;</td><td class="mdescRight">findBook finds books matching query  <a href="#a1e4254bc287282e010057c3e5badb43b">More...</a><br /></td></tr>
<tr class="separator:a1e4254bc287282e010057c3e5badb43b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a973b2ab462d6c953575f0b2da93e4d96"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a973b2ab462d6c953575f0b2da93e4d96">getUsers</a> () const </td></tr>
<tr class="memdesc:a973b2ab462d6c953575f0b2da93e4d96"><td class="mdescLeft">&#160;</td><td class="mdescRight">getUsers gets users (also admins) of library  <a href="#a973b2ab462d6c953575f0b2da93e4d96">More...</a><br /></td></tr>
<tr class="separator:a973b2ab462d6c953575f0b2da93e4d96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4111051c1f0968c5663bb7fd0fef6f44"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_admin.html">Admin</a> &gt; &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a4111051c1f0968c5663bb7fd0fef6f44">getAdmins</a> () const </td></tr>
<tr class="memdesc:a4111051c1f0968c5663bb7fd0fef6f44"><td class="mdescLeft">&#160;</td><td class="mdescRight">getUsers gets admins of library  <a href="#a4111051c1f0968c5663bb7fd0fef6f44">More...</a><br /></td></tr>
<tr class="separator:a4111051c1f0968c5663bb7fd0fef6f44"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77968b77aab5078fad2e3a8149f29c74"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a> () const </td></tr>
<tr class="memdesc:a77968b77aab5078fad2e3a8149f29c74"><td class="mdescLeft">&#160;</td><td class="mdescRight">getBooks gets books in library  <a href="#a77968b77aab5078fad2e3a8149f29c74">More...</a><br /></td></tr>
<tr class="separator:a77968b77aab5078fad2e3a8149f29c74"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a1422cce38ba96fdfc0f552bf9f557420"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#a1422cce38ba96fdfc0f552bf9f557420">operator&lt;&lt;</a> (std::ostream &amp;out, const <a class="el" href="class_library.html">Library</a> &amp;library)</td></tr>
<tr class="memdesc:a1422cce38ba96fdfc0f552bf9f557420"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator &lt;&lt; printer  <a href="#a1422cce38ba96fdfc0f552bf9f557420">More...</a><br /></td></tr>
<tr class="separator:a1422cce38ba96fdfc0f552bf9f557420"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecea69f7dd7e339fe8fee2361611ee68"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_library.html#aecea69f7dd7e339fe8fee2361611ee68">operator&lt;&lt;</a> (std::ostream &amp;out, const <a class="el" href="class_library.html">Library</a> *library)</td></tr>
<tr class="memdesc:aecea69f7dd7e339fe8fee2361611ee68"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator &lt;&lt; printer  <a href="#aecea69f7dd7e339fe8fee2361611ee68">More...</a><br /></td></tr>
<tr class="separator:aecea69f7dd7e339fe8fee2361611ee68"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>model of library with users and books </p>
<p>Copyright 2016-2017 Stefano Fogarollo</p>
<p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</p>
<p><a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a></p>
<p>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a82338219d8bf51962ff5f60a0db21b19"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Library::Library </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Copyright 2016-2017 Stefano Fogarollo</p>
<p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</p>
<p><a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a></p>
<p>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </p>

</div>
</div>
<a class="anchor" id="af4712d4a4733c5e2848129756f3396a4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Library::Library </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_library.html">Library</a> &amp;&#160;</td>
          <td class="paramname"><em>l</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_library.html" title="model of library with users and books ">Library</a> new library. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">l</td><td>const library to copy </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a62120f28a9b50cc5b151d868e42ab936"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Library::~Library </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Deconstructor </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ae18b352bb538f8f7bbef5eba963feec6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Library::addBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>book</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adds new book to library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>new book to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad6479360c5ecb4592ab7df4cedc1d331"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Library::addUser </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>user</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adds new user to library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">user</td><td>new user to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a983f569333bcca8e312e28faf4c31299"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Library::editBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>oldBook</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>newBook</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>replaces selected book with new one </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oldBook</td><td>book to replace </td></tr>
    <tr><td class="paramname">newBook</td><td>new book </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad102e94fb61ef4db352769970c470ffe"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Library::editUser </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>oldUser</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>newUser</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>replaces selected user with new one </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oldUser</td><td>user to replace </td></tr>
    <tr><td class="paramname">newUser</td><td>new user </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1e4254bc287282e010057c3e5badb43b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; Library::findBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>book</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>findBook finds books matching query </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>book to find </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>books matching query </dd></dl>

</div>
</div>
<a class="anchor" id="a525d14bedae90669616814e7bc8b64d2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; Library::findUser </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>user</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>findUser finds users matching query </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">user</td><td>user to find </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>users matching query </dd></dl>

</div>
</div>
<a class="anchor" id="a4111051c1f0968c5663bb7fd0fef6f44"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_admin.html">Admin</a> &gt; &gt; * Library::getAdmins </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>getUsers gets admins of library </p>
<dl class="section return"><dt>Returns</dt><dd>list of admins in library </dd></dl>

</div>
</div>
<a class="anchor" id="a77968b77aab5078fad2e3a8149f29c74"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt; &gt; * Library::getBooks </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>getBooks gets books in library </p>
<dl class="section return"><dt>Returns</dt><dd>list of books in library </dd></dl>

</div>
</div>
<a class="anchor" id="a973b2ab462d6c953575f0b2da93e4d96"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_database.html">Database</a>&lt; <a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt; &gt; * Library::getUsers </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>getUsers gets users (also admins) of library </p>
<dl class="section return"><dt>Returns</dt><dd>list of users in library </dd></dl>

</div>
</div>
<a class="anchor" id="a9b67293035c9287e553fdf375c2c07d4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Library::isBookInDatabase </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_book.html">Book</a>&#160;</td>
          <td class="paramname"><em>book</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if book is in database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>book to find </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true iff book is in database </dd></dl>

</div>
</div>
<a class="anchor" id="a578ce2622f10276289f4818f745ab67e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Library::isUserInDatabase </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_user.html">User</a>&#160;</td>
          <td class="paramname"><em>user</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if user is in database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">user</td><td>user to find </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true iff user is in database </dd></dl>

</div>
</div>
<a class="anchor" id="a553976ddb2812ca85f16d98e747e7e69"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Library::removeBook </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>book</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>removes book from library </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">book</td><td>book to remove </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true iff operation went well </dd></dl>

</div>
</div>
<a class="anchor" id="a237a223c72cc9c46efbc70b05bfc4067"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Library::removeUser </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_smart_pointer.html">SmartPointer</a>&lt; <a class="el" href="class_user.html">User</a> &gt;&#160;</td>
          <td class="paramname"><em>user</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Removes user from library </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">user</td><td>user to remove </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true iff operation goes well </dd></dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a class="anchor" id="a1422cce38ba96fdfc0f552bf9f557420"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_library.html">Library</a> &amp;&#160;</td>
          <td class="paramname"><em>library</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>operator &lt;&lt; printer </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">out</td><td>stream </td></tr>
    <tr><td class="paramname">object</td><td>to print </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>print object </dd></dl>

</div>
</div>
<a class="anchor" id="aecea69f7dd7e339fe8fee2361611ee68"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_library.html">Library</a> *&#160;</td>
          <td class="paramname"><em>library</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>operator &lt;&lt; printer </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">out</td><td>stream </td></tr>
    <tr><td class="paramname">object</td><td>to print </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>print object </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>app/Library/<a class="el" href="_library_8h_source.html">Library.h</a></li>
<li>app/Library/Library.cpp</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_library.html">Library</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
